QB.init('34195', 'TFhe-L46EpzgWFL', 'jeGZCaqfPpfbHQW');

var dev = false;

localStorage['showTutorial'] == null ? localStorage.setItem('showTutorial', true) : localStorage.setItem('showTutorial', '');
localStorage['visitNumber'] == null ? localStorage.setItem('visitNumber', 1) : localStorage.setItem('visitNumber', parseInt(localStorage['visitNumber']) + 1);

angular.module('osmos')
    .value('tokenName', '1Shot_token')
    .value('sessionIdKeyName', 'goc-session-id');

angular.module('app')
    .value('dev', dev)

  .run(['$rootScope', '$state', '$ionicPlatform', '$interval', 'analytics', 'accountManager', 'signalr', 'gaManager',
      function ($rootScope, $state, $ionicPlatform, $interval, analytics, accountManager, signalr, gaManager) {
          $ionicPlatform.ready(function () {
              if (window.cordova && window.cordova.plugins.Keyboard) {
                  cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
                  cordova.plugins.Keyboard.disableScroll(true);
              }
              if (window.StatusBar) {
                  StatusBar.styleDefault();
              }

              gaManager.init();

          });

          analytics.start()
            .success(function () {
                init();
            })
            .error(function (error) {
                console.error('starting analytics error', error);
                init();
            });
          function init() {

              $interval(function () {
                  if (accountManager.userInfo) {
                      if (!signalr.connected) {
                          signalr.init();
                      }
                      else {
                      }
                  }
              }, 1000);

              $rootScope.$watch(function () {
                  return accountManager.userInfo;
              }, function (newValue, oldValue) {

                  if (!newValue) {

                      $state.go('login');

                      if (oldValue) {
                          signalr.stop();
                      }
                      else {
                      }
                  }
                  else {
                      if (!oldValue) {
                          signalr.init();
                          $state.go('app.zero');
                      }
                      else {
                      }
                  }

              });

              accountManager.getUserInfo();
          }

      }])

  .config(['$stateProvider', '$urlRouterProvider', function ($stateProvider, $urlRouterProvider) {

      $stateProvider
        .state('app', {
            url: '/app',
            abstract: true,
            templateUrl: 'app/vcs/layout/menu.html',
        })

        //Without menu

        .state('app.zero', {
            url: "/zero/:instruction",
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: "app/vcs/layout/zero.html",
                    controller: 'zeroCtrl as vm'
                }
            },
            title: 'Chat'
        })
        .state('setProfile', {
            url: "/setProfile",
            cache: false,
            templateUrl: "app/vcs/layout/setProfile.html",
            controller: 'setProfileCtrl as vm'
        })

        .state('matching', {
            url: "/matching/:reload",
            cache: false,
            templateUrl: "app/vcs/matching/matching.html",
            controller: 'matchingCtrl as vm'
        })

        .state('chat', {
            url: "/chat",
            cache: false,
            templateUrl: "app/vcs/matching/chat.html",
            controller: 'chatCtrl as vm',
            title: 'Chat'
        })

        .state('app.friends', {
            url: "/friends",
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: "app/vcs/friends/friends.html",
                    controller: 'friendsCtrl as vm'
                }
            }
        })

        .state('app.textChat', {
            url: "/textChat/:friendshipId",
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: "app/vcs/friends/textChat.html",
                    controller: 'textChatCtrl as vm'
                }
            }
        })

        .state('app.profile', {
            url: "/profile",
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: "app/vcs/profile/profile.html",
                    controller: 'profileCtrl as vm'
                }
            },
            title: 'Profile'
        })
          .state('app.privacy', {
              url: "/privacy",
              cache: false,
              views: {
                  'menuContent': {
                      templateUrl: "app/vcs/profile/privacy.html",
                      controller: 'privacyCtrl as vm'
                  }
              },
              title: 'Privacy'
          })

        .state('app.reports', {
            url: "/reports",
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: "app/vcs/report/reports.html",
                    controller: 'reportsCtrl as vm'
                }
            },
            title: 'Reports'
        })

        .state('app.report', {
            url: "/report/:userId",
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: "app/vcs/report/report.html",
                    controller: 'reportCtrl as vm'
                }
            },
            title: 'Report'
        })

        .state('app.share', {
            url: "/share",
            cache: false,
            views: {
                'menuContent': {
                    templateUrl: "app/vcs/share/share.html",
                    controller: 'shareCtrl as vm'
                }
            },
            title: 'Share'
        })

        //Without menu

        .state('login', {
            url: "/login",
            cache: false,
            templateUrl: "app/vcs/account/login/login.html",
            controller: 'loginCtrl as vm',
            resolve: {
                facebookStatus: function (facebookManager) {
                    facebookManager.getLoginStatus()
                        .then(function () {
                            return true;
                        }).catch(function () {
                            return false;
                        });
                }
            }
        })

        .state('register', {
            url: "/register",
            cache: false,
            templateUrl: "app/vcs/account/register/register.html",
            controller: 'registerCtrl as vm'
        });

      $urlRouterProvider.otherwise('/zero');
  }]);
