﻿(function () {
    angular.module('app').factory('friendshipsManager', ['httpService', function (httpService) {

        var urlPrefix = 'api/friendships/';

        return {
            hasUnseenFriendRequests: false,

            create: function (mateId) {
                return httpService.post({
                    url: urlPrefix,
                    data: {
                        mateId: mateId
                    }
                });
            },
            getAll: function (userId) {

                var self = this;

                self.getHasUnseenFriendRequests();

                return httpService.get({
                    url: urlPrefix
                });
            },
            getOne: function (friendshipId) {
                return httpService.get({
                    url: urlPrefix + friendshipId
                });
            },
            delete: function (friendshipId) {
                return httpService.delete({
                    url: urlPrefix + friendshipId
                });
            },
            accept: function (friendshipId) {
                return httpService.patch({
                    url : urlPrefix + friendshipId + '/accept'
                });
            },
            reject: function (friendshipId) {
                return httpService.patch({
                    url: urlPrefix + friendshipId + '/reject'
                });
            },
            seen: function (args) {
                return httpService.patch({
                    url: urlPrefix + 'seen',
                    data: args
                });
            },
            getHasUnseenFriendRequests: function () {
                var self = this;

                httpService.get({
                    url: urlPrefix + 'hasUnseenFriendRequests'
                })
                .success(function (data) {
                    self.hasUnseenFriendRequests = angular.copy(data);
                });
            }
        };

    }]);
}());