(function(){
    angular.module('app').factory('gaManager', [function(){

        // var googleAnalyticsId = 'UA-96358609-1';
        var googleAnalyticsId = 'UA-81403114-1';

        return {
            init: function(){
                if (window.cordova) {
                    window.ga.startTrackerWithId(googleAnalyticsId, 30, function (e) {
                        console.log('Google analytics is ready now');
                        window.ga.trackView('GOC App Start');
                        window.ga.debugMode();
                        window.ga.setAllowIDFACollection(true);
                        //   var url = 'https://play.google.com/store/apps/details?id=com.symbiosys.gameofchat&referrer=utm_source%3Dgoogle%26utm_medium%3Dcpc%26utm_term%3Dgoc%26utm_content%3Dgoc%26utm_campaign%3Dgoc%2520test%2520campaine%26anid%3Dadmob';
                        //   window.ga.trackView('GOC App Start 123', url);
                    }, function (e) {
                        console.log('Error starting GoogleAnalytics', e);
                    });

                } else {
                    (function (i, s, o, g, r, a, m) {
                        i['GoogleAnalyticsObject'] = r; i[r] = i[r] || function () {
                            (i[r].q = i[r].q || []).push(arguments)
                        }, i[r].l = 1 * new Date(); a = s.createElement(o),
                        m = s.getElementsByTagName(o)[0]; a.async = 1; a.src = g; m.parentNode.insertBefore(a, m)
                    })(window, document, 'script', 'https://www.google-analytics.com/analytics.js', 'ga');

                    ga('create', googleAnalyticsId, 'auto');
                    ga('send', 'pageview');
                };
                gaEvent('device_ready_event', 'event', 'Visiting number: ' + localStorage['visitNumber']);
            },
            fbLogin: function () {
                gaEvent('fb_login_button', 'fb_id_response', 'Facebook login');
            },
            startChat: function () {
                gaEvent('start_chat_button', 'click', 'Start chat');
            },
            endChat: function () {
                gaEvent('stop_chat_button', 'click', 'Stop chat');
            },
            firstQuestion: function () {
                gaEvent('question_choice_select', 'click', 'Answer on first question');
            },
            secondQuestion: function () {
                gaEvent('question_choice_select', 'click', 'Answer on first question');
            },
            startMatching: function () {
                gaEvent('question_choice_select', 'no_more_questions_condition', 'Start matching');
            },
            endMatching: function () {
                gaEvent('stop_matching_button', 'click', 'Stop matching');
            },
            addFriend: function () {
                gaEvent('add_friend_button', 'click', 'Add friend');
            },
            sendMessage: function () {
                gaEvent('send_message_button', 'click', 'Send message');
            },
            share: function (via) {
                gaEvent(via + '_share_button', 'click', 'Share on ' + via);
            }
        };

        function gaEvent(category, action, label) {
            if (ionic.Platform.is('browser') || typeof cordova == "undefined") {
                ga('send', 'event', {
                    eventCategory: category,
                    eventAction: action,
                    eventLabel: label
                });
            } else {
                window.ga.trackEvent(category, action, label)
            }
        };

    }]);
}());