﻿(function () {
    angular.module('app').factory('messagesManager', ['httpService', function (httpService) {

        var urlPrefix = 'api/messages/';

        return {
            hasUnseenMessages: false,
            sendMessage: function (friendshipId, text) {
                return httpService.post({
                    url: urlPrefix,
                    data: {
                        friendshipId: friendshipId,
                        text: text
                    }
                });
            },
            getMessages: function (friendshipId) {

                var self = this;

                //self.getHasUnseenMessages();

                return httpService.get({
                    url: urlPrefix + friendshipId
                });
            },
            seen: function (args) {
                return httpService.patch({
                    url: urlPrefix,
                    data: args
                });
            },
            getHasUnseenMessages: function () {
                var self = this;

                return httpService.get({
                    url: urlPrefix + 'hasUnseenMessages'
                })
                .success(function (data) {
                    self.hasUnseenMessages = angular.copy(data);
                });
            },
            getUnseenMessagesUserIds: function () {
                var self = this;

                return httpService.get({
                    url: urlPrefix + 'unseenMessagesUserIds'
                });
            }
        };

    }]);
}());