﻿(function () {
    angular.module('app').factory('quizzManager', ['httpService', function (httpService) {

        var urlPrefix = 'api/quizz/';

        return {
            getQuestions: function () {
                return httpService.get({
                    url: urlPrefix
                });
            },
            answerQuestions: function (args) {
                return httpService.post({
                    url: urlPrefix,
                    data: args
                });
            },
            getCommonInterests: function (qbOpponentId) {
                return httpService.get({
                    url: urlPrefix + 'commonInterests/' + qbOpponentId
                });
            },
            getQuestionFromChoice: function (qcId) {
                return httpService.get({
                    url: urlPrefix + 'questionFromChoice/' + qcId
                });
            }
        };

    }]);
}());