﻿(function () {
    angular.module('app').factory('sharesManager', ['httpService', 'toastManager','accountManager', function (httpService, toastManager,accountManager) {

        var basUrl = 'api/shares/';

        return {
            addCredits: function () {
                var credits = angular.copy(accountManager.userInfo.credits);

                return httpService.post({
                    url: basUrl + 'addCredits'
                }).success(function (response) {
                    credits = credits + 5;
                    toastManager.showSuccess('You have received 5 credits.', '<div class="text-center">Total credits: '  + credits +'</span>');
                }).error(function (response, statusCode) {
                    if (statusCode == 304) {
                        toastManager.showError('You have already received free credits today.', '<div class="text-center">Total credits: ' + credits + '</span>');
                    } else {
                        toastManager.showError('You have not received free credits due to server error: ' + statusCode, '<div class="text-center">Total credits: ' + credits + '</span>');
                    }
                        
                });
            }
        };

    }]);
}());