﻿(function () {

    angular.module('app').factory('textsManager', ['httpService', function (httpService) {

        var urlPrefix = 'api/texts/';

        return {
            texts: [],
            getText: function (name) {

                var self = this;

                var promise = null;

                var text = _.find(self.texts, function (item) {
                    return item.name === name;
                });

                if (text) {
                    promise = httpService.createEmptyPromise(text);
                }
                else {
                    promise = httpService.get({
                        url: urlPrefix + '?name=' + name
                    })
                    .success(function (data) {
                        self.texts.push(data);
                    });
                }

                return promise;
            }
        };

    }]);
}());