﻿(function () {
    angular.module('app').factory('analytics', ['httpService', function (httpService) {

        var urlPrefix = 'api/analytics/';

        return {
            start: function () {
                return httpService.post({
                    url: urlPrefix + 'start'
                })
                .success(function (data) {
                    httpService.setSessionId(data.id);
                })
                .error(function (error) {
                    console.error('analytics error', error);
                });
            },
            pageActivated: function (pageName) {
                var self = this;

                return self.log({
                    name: 'pageActivated',
                    targets: [{
                        id: pageName
                    }],
                    level: 'trace',
                    type: 'event'
                })
                .error(function (error) {
                    console.error('analytics error', error);
                });
            },
            event: function (eventName, targets) {
                var self = this;

                return self.log({
                    name: eventName,
                    targets: targets || null,
                    level: 'trace',
                    type: 'event'
                })
                .error(function (error) {
                    console.error('analytics error', error);
                });
            },
            action: function (actionName, targets) {
                var self = this;

                return self.log({
                    name: actionName,
                    targets: targets || null,
                    level: 'trace',
                    type: 'action'
                })
                .error(function (error) {
                    console.error('analytics error', error);
                });
            },
            log: function (args) {
                return httpService.post({
                    url: urlPrefix + 'log',
                    data: args
                })
                .error(function (error) {
                    console.error('analytics error', error);
                });
            }
        };

    }]);
}());