﻿(function () {
    angular.module('app').controller('menuCtrl', ['$rootScope', '$state', '$ionicModal', '$scope', '$ionicPlatform', '$cordovaSocialSharing', 'accountManager', 'friendshipsManager', 'messagesManager', 'analytics',
    function ($rootScope, $state, $ionicModal, $scope, $ionicPlatform, $cordovaSocialSharing, accountManager, friendshipsManager, messagesManager, analytics) {

        var vm = this;

        vm.hasUnseenMessages = angular.copy(messagesManager.hasUnseenMessages);
        vm.stateName = null;
        vm.showTutorial = localStorage['showTutorial'];

        $rootScope.$on('openMenu', function () {
            $scope.modal.show();
        });

        $rootScope.$on('$stateChangeSuccess',
        function (event, toState, toParams, fromState, fromParams) {
            if (toState && toState.name) {
                vm.stateName = toState.name;
            }
            else {
                vm.stateName = null;
            }
        });

        $rootScope.$on('friendNameHasChanged', function (event, friendName) {
            vm.friendName = friendName;
        });

        vm.hasUnseenFriendRequests = angular.copy(friendshipsManager.hasUnseenFriendRequests);
        $rootScope.$watch(function () {
            return friendshipsManager.hasUnseenFriendRequests;
        }, function () {
            vm.hasUnseenFriendRequests = angular.copy(friendshipsManager.hasUnseenFriendRequests);
        });
        friendshipsManager.getHasUnseenFriendRequests();
        
        messagesManager.getHasUnseenMessages().success(function () {
            vm.hasUnseenMessages = angular.copy(messagesManager.hasUnseenMessages);
        });
        
        $rootScope.$watch(function () {
            return messagesManager.hasUnseenMessages;
        }, function () {
            vm.hasUnseenMessages = angular.copy(messagesManager.hasUnseenMessages);
        });

        $ionicModal.fromTemplateUrl('my-modal.html', {
            scope: $scope,
            animation: 'slide-in-up'
        }).then(function (modal) {
            $scope.modal = modal;
        });

        vm.exitTextChat = function () {
            $state.go('app.friends');
            analytics.action('exit chat');
        }

        vm.openModal = function () {
            $scope.modal.show();
        }

        vm.closeModal = function () {
            $scope.modal.hide();
        }

        vm.logout = function () {
            accountManager.logout()
            .success(function () {
                vm.closeModal();
                analytics.action('logout');
                $state.go('login');
            });
        }

    }]);

}());
