﻿(function () {
    angular.module('app').controller('setProfileCtrl', ['$rootScope', '$state', '$scope', '$ionicModal', 'accountManager', 'analytics', 'signalr', 'deviceManager',
        function ($rootScope, $state, $scope, $ionicModal, accountManager, analytics, signalr, deviceManager) {
            var vm = this;

            analytics.pageActivated('setProfile');


            vm.sexualProfile = {
                gender: '',
                interestedInFemales: true,
                interestedInMales: true
            };

            vm.userInfo = null;
            vm.displayName = null;

            vm.sessionsCount = signalr.sessionsCount;
            $rootScope.$watch(function () {
                return signalr.sessionsCount;
            }, function () {
                vm.sessionsCount = signalr.sessionsCount;
            });


            vm.firstPageStartSearchingForMate = function () {
                accountManager.setSawFirstPage()
                .success(function () {
                    $state.go('matching');
                    analytics.action('start chat from first login page');
                });
            }

            vm.toggleIntersetedInFemales = function () {
                if (vm.sexualProfile.interestedInFemales && !vm.sexualProfile.interestedInMales) {
                    vm.sexualProfile.interestedInMales = true;
                    vm.sexualProfile.interestedInFemales = false;
                    
                }else{
                    vm.sexualProfile.interestedInFemales = !vm.sexualProfile.interestedInFemales
                    if (vm.sexualProfile.interestedInMales) accountManager.toggleIntersetedInFemales();
                }

                accountManager.toggleIntersetedInFemales();
                analytics.action('toggleIntersetedInFemales');
            }

            vm.toggleIntersetedInMales = function () {
                if (vm.sexualProfile.interestedInMales && !vm.sexualProfile.interestedInFemales) {
                    vm.sexualProfile.interestedInFemales = true;
                    vm.sexualProfile.interestedInMales = false;
                    accountManager.toggleIntersetedInFemales();
                } else {
                    vm.sexualProfile.interestedInMales = !vm.sexualProfile.interestedInMales
                    if (vm.sexualProfile.interestedInMales) accountManager.toggleIntersetedInMales();
                }

                
                analytics.action('toggleIntersetedInMales');
            }

            vm.toggleGender = function (val) {
                vm.sexualProfile.gender = val;
                accountManager.updateSexualInterests(vm.sexualProfile);
                analytics.action('toggleGender');
            }

            getUserInfo();

            function getUserInfo() {
                accountManager.getUserInfo()
                    .success(function (data) {

                        vm.userInfo = data;
                        vm.displayName = vm.userInfo.displayName;

                        vm.sexualProfile.gender = vm.userInfo.gender;

                        $rootScope.$watch(function () {
                            return vm.displayName;
                        }, function () {
                            if (vm.displayName && vm.displayName.length > 0) {
                                accountManager.updateDisplayName(vm.displayName);
                            }
                        });
                    })
                .error(function (error) {
                    console.error('zero userInfo error', error);
                });
            }

        }]);
}());
