﻿(function () {
    angular.module('app').controller('zeroCtrl', ['$rootScope', '$state', '$stateParams', '$scope', '$ionicModal', 'accountManager', 'analytics', 'signalr', 'deviceManager', 'textsManager', 'gaManager',
        function ($rootScope, $state, $stateParams, $scope, $ionicModal, accountManager, analytics, signalr, deviceManager, textsManager, gaManager) {
            var vm = this;

            analytics.pageActivated('zero');

            console.info('$stateParams', $stateParams);
            if ($stateParams.instruction === 'openMenu') {
                $rootScope.$emit('openMenu');
            }
            else if($stateParams.instruction === 'goToMatching'){
                $state.go('matching');
            }

            vm.userInfo = null;

            vm.text = 'Welcome back !';

            vm.sessionsCount = signalr.sessionsCount;
            $rootScope.$watch(function () {
                return signalr.sessionsCount;
            }, function () {
                vm.sessionsCount = signalr.sessionsCount;
            });

            vm.startSearchingForMate = function () {

                analytics.action('start chat');
                gaManager.startChat();
                deviceManager.requestLocationAuthorization()
                    .then(function(result){
                        console.info('requestLocationAuthorization success', result);
                        $state.go('matching');                            
                    })
                    .catch(function(error){
                        console.error('requestLocationAuthorization', error);
                        $state.go('matching');                            
                    });
                
            }

            getUserInfo();

            function getUserInfo() {
                accountManager.getUserInfo()
                    .success(function (data) {
                        vm.userInfo = data;
                        if (!vm.userInfo.sawFirstPage) $state.go('setProfile');
                        //$state.go('setProfile');


                        getText();
                    })
                .error(function (error) {
                    console.error('zero userInfo error', error);
                });
            }

            function getText() {
                
                textsManager.getText('welcome')
                .success(function (data) {

                    if (data.content) vm.text = data.content.format(vm.userInfo.displayName);

                })
                .error(function (error) {
                    console.error(error);
                });

            }

        }]);
}());
