﻿(function () {
    angular.module('app').controller('profileCtrl', ['$rootScope', 'accountManager', 'deviceManager', 'analytics', function ($rootScope, accountManager, deviceManager, analytics) {
        var vm = this;

        analytics.pageActivated('profile');

        vm.profilePhoto = null;

        vm.displayName = null;

        vm.sexualProfile = {
            gender: 'Female',
            interestedInFemales: false,
            interestedInMales: false
        };

        vm.updateName = function () {
            console.info(vm.name);
            accountManager.updateName(vm.name)
            .error(function () {
                getUserInfo();
            });

            analytics.action('update name');
        }


        vm.takePhoto = function () {

            vm.imageData = null;

            deviceManager.takePhoto(function (data) {

                vm.imageData = data;

                accountManager.updateProfilePhoto(data)
                .success(function () {
                    getUserInfo();
                })
                .error(function (error) {
                });

            }, function (error) {
            });

            analytics.action('take photo');
        };

        vm.toggleIntersetedInFemales = function () {

            vm.userInfo.interestedInFemales = !vm.userInfo.interestedInFemales;

            if (!vm.userInfo.interestedInMales && !vm.userInfo.interestedInFemales) {
                vm.userInfo.interestedInFemales = !vm.userInfo.interestedInFemales;
                return;
            }

            accountManager.toggleIntersetedInFemales();

            analytics.action('toggleIntersetedInFemales');
        }

        vm.toggleIntersetedInMales = function () {

            vm.userInfo.interestedInMales = !vm.userInfo.interestedInMales;

            if (!vm.userInfo.interestedInMales && !vm.userInfo.interestedInFemales) {
                vm.userInfo.interestedInMales = !vm.userInfo.interestedInMales;
                return;
            }

            accountManager.toggleIntersetedInMales();

            analytics.action('toggleIntersetedInMales');
        }

        if (accountManager.userInfo) {
            vm.sexualProfile = {
                gender: accountManager.userInfo.gender,
                interestedInFemales: accountManager.userInfo.interestedInFemales,
                interestedInMales: accountManager.userInfo.interestedInMales
            };

            vm.displayName = accountManager.userInfo.displayName;
        }

        $rootScope.$watch(function () {
            return vm.displayName;
        }, function () {
            if (vm.displayName && vm.displayName.length > 0) {
                accountManager.updateDisplayName(vm.displayName);
            }
        });

        getUserInfo();

        function getUserInfo() {
            accountManager.getUserInfo()
                .success(function (data) {

                    vm.userInfo = data;

                    vm.profilePhoto = data.profilePhoto;

                    vm.sexualProfile = {
                        gender: accountManager.userInfo.gender,
                        interestedInFemales: accountManager.userInfo.interestedInFemales,
                        interestedInMales: accountManager.userInfo.interestedInMales
                    };

                    vm.name = {
                        firstName: accountManager.userInfo.firstName,
                        lastName: accountManager.userInfo.lastName
                    };

                    $rootScope.$watch(function () {
                        return vm.sexualProfile;
                    }, function () {
                        accountManager.updateSexualInterests(vm.sexualProfile);
                    }, true);
                });
        }

    }]);
}());