﻿(function () {
    angular.module('app').controller('reportCtrl', ['$state', '$stateParams', 'usersManager', 'enumsManager', 'reportsManager', 'analytics',
        function ($state, $stateParams, usersManager, enumsManager, reportsManager, analytics) {
            var vm = this;

            analytics.pageActivated('report');

            vm.user = null;

            vm.reportTypes = [];
            vm.reportType = null;

            vm.report = function () {
                reportsManager.createReport({
                    targetId: vm.user.id,
                    type: vm.reportType
                })
                .success(function () {
                    $state.go('app.zero');
                });

                analytics.action('submit report', [{
                    id: vm.user.id
                }]);
            }

            vm.cancel = function () {
                $state.go('app.zero');

                analytics.action('cancel report', [{
                    id: vm.user.id
                }]);
            }

            getUser();
            getReportTypes();

            function getReportTypes() {
                enumsManager.getReportTypes()
                .success(function (data) {
                    vm.reportTypes = angular.copy(data);
                    vm.reportType = vm.reportTypes[0];
                });
            }
            
            function getUser() {
                usersManager.getUser($stateParams.userId)
                .success(function (data) {
                    vm.user = angular.copy(data);
                });
            }

        }]);
}());