﻿(function () {
    angular.module('app').controller('reportsCtrl', ['reportsManager', 'analytics', function (reportsManager, analytics) {
        var vm = this;

        analytics.pageActivated('reports');

        vm.reportedByMe = [];
        vm.reportedByOthers = [];

        getReportedByMe();
        getReportedByOthers();

        function getReportedByMe() {
            reportsManager.getReportedByMe()
            .success(function (data) {
                vm.reportedByMe = _.map(data, function (item) {
                    if (item.createdDate) {
                        item.createdDate = moment(item.createdDate).format('dddd MMM Do YYYY HH:mm');
                    }

                    return item;
                });

                console.info('vm.reportedByMe', vm.reportedByMe);
            });
        }

        function getReportedByOthers() {
            reportsManager.getReportedByOthers()
            .success(function (data) {
                vm.reportedByOthers = _.map(data, function (item) {
                    if (item.createdDate) {
                        item.createdDate = moment(item.createdDate).format('dddd MMM Do YYYY HH:mm');
                    }

                    return item;
                });

                console.info('vm.reportedByOthers', vm.reportedByOthers);

            })
        }

    }]);
}());