﻿(function () {
    angular.module('app').controller('shareCtrl', ['$window', 'configurationManager', 'sharesManager', 'gaManager',
        function ($window, configurationManager, sharesManager, gaManager) {

            var vm = this;

            var url = 'http://gameofchat.com/';
            var facebookMessage = '';
            var twitterMessage = '';

            vm.disableShare = true;

            vm.shareViaFacebook = function () {

                var social = 'facebook';

                gaManager.share(social);

                if (window && window.plugins && window.plugins.socialsharing) {
                    window.plugins.socialsharing.shareViaFacebook(facebookMessage, null, url, function () {
                        sharesManager.addCredits();
                    }, function (error) {
                        regularShare(social);
                    });
                }
                else {
                    regularShare(social);
                }
            }

            vm.shareViaTwitter = function () {

                var social = 'twitter';

                gaManager.share(social);

                if (window && window.plugins && window.plugins.socialsharing) {
                    window.plugins.socialsharing.shareViaTwitter(twitterMessage, null, url, function () {
                        sharesManager.addCredits();
                    }, function (error) {
                        regularShare(social);
                    });
                }
                else {
                    regularShare(social);
                }
            }

            getConfiguration();

            function getConfiguration() {
                configurationManager.getConfiguration()
                .then(function (data) {
                    vm.disableShare = false;

                    if (data) {
                        url = data.gocWebSiteUrl;
                        facebookMessage = data.gocShareFacebookMessage;
                        twitterMessage = data.gocShareTwitterMessage;
                    }

                    vm.disableShare = false;
                })
                .catch(function (error) {
                    vm.disableShare = false;
                    console.error('getConfiguration error', error);
                });
            }

            function regularShare(social) {

                var encodedUrl = null;

                if (social === 'twitter') {
                    encodedUrl = encodeURIComponent(twitterMessage);
                }
                else {
                    encodedUrl = encodeURIComponent(url);
                }

                var redirect = null;
                if (social === 'facebook') {
                    redirect = 'https://www.facebook.com/sharer/sharer.php?u=' + encodedUrl + '&src=sdkpreparse';
                }
                else if (social === 'twitter') {
                    redirect = 'https://twitter.com/intent/tweet?text=' + encodedUrl;
                }

                $window.open(redirect, '_blank');

                sharesManager.addCredits();
            }

        }]);
}());