## Contributing

### New Here and want to help?

First off, Welcome!  NgCordova is possible because of your support.  There are a lot of community plugins out there; many more than any one person could maintain and support.  Likewise, the wrappers take a level of support that no one person could provide on their own.  We need your help.  If you've never contributed to open source before, now's your chance.  There are lots of things you can do to help.

If you're nervous about writing plugin wrappers (It's really not as hard as it looks), there is lots you can do:

 - Report bugs!  When reporting a bug, please include a [Minimal, Complete, Verifiable Example](http://stackoverflow.com/help/mcve). These are important because it gets us much closer to fixing the bug you've found, and it verifies that this is an actual bug.  When creating an MCVE, feel free to put it in a public repo and linking to it in your issue.  The closer we can get to simply building your repo and running it, the more likely we're able to fix the issue quickly.  If a bug report doesn't include an MCVE, we'll probably have to close it.  
 - Improve the documentation!  Documentation is boring, but it's the first thing newcomers see.  If you think the documentation can be improved, submit a pull request that improves it.  How to do that is included below.
 
#### I want a new plugin included in NgCordova

Awesome!  Please write a wrapper for it to ensure we get it in as quickly as possible.  Not sure how to do that? I've included references in issue #885.

#### *Plugin I Use* is no longer maintained/supported

Create a pull request that updates the README.md with the version of Cordova that plugin works with; and if there's a new plugin that is supported, please help us by writing a wrapper for it.  

#### Creating an Issue

If you have a problem with ng-cordova, you can [submit a new Issue](https://github.com/driftyco/ng-cordova/issues/new). Please be detailed in your issue report, and include keywords such as : `Feat`, `Bug`, etc

If you think you have found a bug, or have a new feature idea, please start by making sure it hasn't already been reported. You can [search through existing issues](https://github.com/driftyco/ng-cordova/issues?state=open) to see if someone's reported one similar to yours.


#### Making edits to ng-cordova

1. [Fork](https://github.com/driftyco/ng-cordova/fork) then clone `git clone git@github.com:your-username/ng-cordova.git` ng-cordova repository
2. Create a new branch in your personally forked repo, with a name similar to your edits, such as `fix-facebook-plugin`
3. Make your edits inside your new branch
4. Commit them and push them back to your personal github fork
5. Make a new [Pull Request](https://github.com/driftyco/ng-cordova/compare/) on the ng-cordova repo. Point your branch to the `dev-next` ng-cordova branch and submit.


#### Fix the Docs

1. [Fork](https://github.com/driftyco/ng-cordova/fork) and clone
2. Create a new branch from the `gh-pages` branch
3. Make your edits
4. Push your edits back to your personal github repo
5. Make a [Pull Request](https://github.com/driftyco/ng-cordova/compare/) on the ng-cordova repo. Point your branch to the `gh-pages` branch and submit


##### License

By contributing your code to the driftyco/ionic GitHub Repository, you agree to license your contribution under the MIT license.

##### Contributor's Convenant

Please note that this project is released with a Contributor Code of Conduct. By participating in this project you agree to abide by its terms.
